/**
 * A brief explanation for "project.json":
 * Here is the content of project.json file, this is the global configuration for your game, you can modify it to customize some behavior.
 * The detail of each field is under it.
 {
    "project_type": "javascript",
    // "project_type" indicate the program language of your project, you can ignore this field

    "debugMode"     : 1,
    // "debugMode" possible values :
    //      0 - No message will be printed.
    //      1 - cc.error, cc.assert, cc.warn, cc.log will print in console.
    //      2 - cc.error, cc.assert, cc.warn will print in console.
    //      3 - cc.error, cc.assert will print in console.
    //      4 - cc.error, cc.assert, cc.warn, cc.log will print on canvas, available only on web.
    //      5 - cc.error, cc.assert, cc.warn will print on canvas, available only on web.
    //      6 - cc.error, cc.assert will print on canvas, available only on web.

    "showFPS"       : true,
    // Left bottom corner fps information will show when "showFPS" equals true, otherwise it will be hide.

    "frameRate"     : 60,
    // "frameRate" set the wanted frame rate for your game, but the real fps depends on your game implementation and the running environment.

    "id"            : "gameCanvas",
    // "gameCanvas" sets the id of your canvas element on the web page, it's useful only on web.

    "renderMode"    : 0,
    // "renderMode" sets the renderer type, only useful on web :
    //      0 - Automatically chosen by engine
    //      1 - Forced to use canvas renderer
    //      2 - Forced to use WebGL renderer, but this will be ignored on mobile browsers

    "engineDir"     : "frameworks/cocos2d-html5/",
    // In debug mode, if you use the whole engine to develop your game, you should specify its relative path with "engineDir",
    // but if you are using a single engine file, you can ignore it.

    "modules"       : ["cocos2d"],
    // "modules" defines which modules you will need in your game, it's useful only on web,
    // using this can greatly reduce your game's resource size, and the cocos console tool can package your game with only the modules you set.
    // For details about modules definitions, you can refer to "../../frameworks/cocos2d-html5/modulesConfig.json".

    "jsList"        : [
    ]
    // "jsList" sets the list of js files in your game.
 }
 *
 */
//
//CCBoot.js
//
/**
 * Check the obj whether is function or not
 * @param {*} obj
 * @returns {boolean}
 */
cc.isFunction = function(obj){
	return typeof obj == 'function';
};

/**
 * Check the obj whether is number or not
 * @param {*} obj
 * @returns {boolean}
 */
cc.isNumber = function(obj){
	return typeof obj == 'number' || Object.prototype.toString.call(obj) == '[object Number]';
};

/**
 * Check the obj whether is string or not
 * @param {*} obj
 * @returns {boolean}
 */
cc.isString = function(obj){
	return typeof obj == 'string' || Object.prototype.toString.call(obj) == '[object String]';
};

/**
 * Check the obj whether is array or not
 * @param {*} obj
 * @returns {boolean}
 */
cc.isArray = function(obj){
	return Object.prototype.toString.call(obj) == '[object Array]';
};

/**
 * Check the obj whether is undefined or not
 * @param {*} obj
 * @returns {boolean}
 */
cc.isUndefined = function(obj){
	return typeof obj == 'undefined';
};

/**
 * Check the obj whether is object or not
 * @param {*} obj
 * @returns {boolean}
 */
cc.isObject = function(obj){
	var type = typeof obj;

	return type == 'function' || (obj && type == 'object');
};

function setRes(){

}

var SDKConf = {
	PLAT_SELF         : {className: "com/friendivity/hsll", platNo: "1", isSdk: false, sdkLogin: false},// 无平台
	PLAT_UC           : {className: "com/friendivity/hsll", platNo: "39", isSdk: true, sdkLogin: true},//UC版
	PLAT_TENCENT_YYB  : {className: "com/tencent/tmgp/hsll", platNo: "6", isSdk: true, sdkLogin: true},// 包括qq和微信登录，这个在android工程meiwei_platform_protocol中的PlatformConfig中的Tencent接口下修改,来决定用微信登录还是qq登录
	PLAT_TENCENT_YYB_HSXXL: {className: "com/tencent/tmgp/hsxxl", platNo: "152", isSdk: true, sdkLogin: true},// 包括qq和微信登录，这个在android工程meiwei_platform_protocol中的PlatformConfig中的Tencent接口下修改,来决定用微信登录还是qq登录	
	PLAT_CT           : {className: "com/friendivity/hsll", platNo: "19", isSdk: true, sdkLogin: false},// 电信
	PLAT_CMCC         : {className: "com/friendivity/hsll", platNo: "40", isSdk: true, sdkLogin: false},// 移动单机版
	PLAT_CUCC         : {className: "com/friendivity/hsll", platNo: "56", isSdk: true, sdkLogin: false},// 联通
	PLAT_91           : {className: "com/friendivity/hsll", platNo: "7", isSdk: true, sdkLogin: true},// 91登录
	PLAT_APPSTORE     : {className: "com/friendivity/hsll", platNo: "123", isSdk: false, sdkLogin: false},// 苹果appstore
	PLAT_BD           : {className: "com/friendivity/hsll", platNo: "113", isSdk: true, sdkLogin: true},//百度
	PLAT_IAPPPAY      : {className: "com/friendivity/hsll", platNo: "124", isSdk: false, sdkLogin: false},//爱贝支付偶像版
	PLAT_CMCC_ONLINE  : {className: "com/friendivity/hsll", platNo: "125", isSdk: true, sdkLogin: true},//移动基地网游版
	PLAT_KY           : {className: "com/friendivity/hsll", platNo: "126", isSdk: true, sdkLogin: true},// 快用越狱ios
	PLAT_APPSTORE_IDOL: {className: "com/friendivity/hsll", platNo: "127", isSdk: false, sdkLogin: false},// 偶像版本接appstore
	PLAT_CHENGZI	: {className: "cn/cmgame/hsxxl", platNo: "155", isSdk: true, sdkLogin: false},// 橙子游戏代理移动
	PLAT_CMCC_UC	: {className: "cn/cmgame/hsll/uc", platNo: "156", isSdk: true, sdkLogin: false},// 移动分包UC
	PLAT_CMCC_OPPO	: {className: "cn/cmgame/hsll/oppo", platNo: "157", isSdk: true, sdkLogin: false},// 移动分包oppo
	PLAT_CMCC_MI	: {className: "cn/cmgame/hsll/mi", platNo: "158", isSdk: true, sdkLogin: false},// 移动分包小米
	PLAT_CMCC_QIHU	: {className: "cn/cmgame.hsll/qihu", platNo: "159", isSdk: true, sdkLogin: false},// 移动分包奇虎360
	PLAT_ANYSDK       : {className: "com/friendivity/hsll", platNo: "9999", isSdk: true, sdkLogin: true}//anysdk
};

cc.checkNetState = function(){
	var ret = 0;
	if(!cc.sys.isNative){
		return ret;
	}
    if(cc.sys.os == cc.sys.OS_IOS){
        return jsb.reflection.callStaticMethod("NativeOcSdk","getNetState");
    }
    else {
    	var preloadFileName = jsb.fileUtils.getWritablePath() + "hsll_preload_data.txt";
    	//	cc.log("preloadFileName" + preloadFileName);
    	var text = jsb.fileUtils.getStringFromFile(preloadFileName);
    	//	cc.log("*************" + text);
    	var preloadJson = JSON.parse(text);
    	cc.log("*************hsll_preload_data:" + text);
    	if(preloadJson["plat_name"]){
    		var TARGET_PLAT = SDKConf[preloadJson["plat_name"]];
    		var className = TARGET_PLAT.className;
    		var platNo = TARGET_PLAT.platNo;
    		cc.log("***************_mClassName:" + className);
    		cc.log("***************_mPlatNo:" + platNo);
    		var sig = "()I";
    		return jsb.reflection.callStaticMethod(className + "/AnySdkUtils", "getNetState", sig);
    	}
    	else{
    	}
    	return ret;
    }
};


// 是否开启热更新
bHotUpdate = true;
bSvrUpdate = true;
adType = "gdt";

if(cc.sys.isNative && cc.checkNetState() == 0){
	bHotUpdate = false;
}

if(cc.sys.isNative){
	// api域名默认值，理论上用不到，会从project.manifest里获取
	g_strApiDomain = "http://hsjsb.gz.1251011433.clb.myqcloud.com/";
	g_strApiDomainTest = "http://61.174.9.194/hsll_mobile/";
    g_strUserDomain = "http://llkmobi.gz.1251013299.clb.myqcloud.com/";// 用户注册管理的域名
}

function NativeStartGame(){
    if(bHotUpdate && bSvrUpdate){
        cc.director.runScene(new HotUpdateScene());
    }
    else{
        cc.loader.loadJs(["src/jsb_jsFiles.js"], function(err){
            cc.loader.loadJs(jsFiles, function(err){
                setRes();
                AnySdkUtils.init();
                cc.director.runScene(new HelloWorldScene());
            });
        });
    }
}

cc.game.onStart = function(){

	//load resources

	if(!cc.sys.isNative){

		window.scrollTo(0, 1);

		var divLoad = document.getElementById("divLoad");
		if(divLoad){
			divLoad.parentNode.removeChild(divLoad);
		}

		/*var foot = document.getElementById("foot");
		 var canvasSize = cc.view.getFrameSize();
		 if(foot && canvasSize.height < canvasSize.width/640*960)
		 {
		 cc.view.setFrameSize(canvasSize.width,canvasSize.width/640*960);
		 }*/

		// cc.LoaderScene.preload(createResArray(res), function () {
		cc.director.runScene(new HelloWorldScene());
		// }, this);

		/*setRes();
		 cc.view.setResizeCallback(setRes);*/
	}
	else{
        var storagePath = jsb.fileUtils.getWritablePath();
		cc.log("write able path [%s]", jsb.fileUtils.getWritablePath());
        
		var text = jsb.fileUtils.getStringFromFile("res/project.manifest");
		var packManifest = JSON.parse(text);
		g_strApiDomain = packManifest.apiDomain;
        /*
		var packVer = "20150416";
		var localVer = cc.sys.localStorage.getItem("localVer");
		if(localVer < packVer || !bHotUpdate){
			// 1,不热更新，调试状态
			// 2,玩家本地记载的版本号下于包里的版本号，玩家重新下载了安装包，把热更新目录清掉。第一次进游戏localVer为空，也符合条件
			var storagePath = jsb.fileUtils.getWritablePath();
			jsb.fileUtils.removeDirectory(storagePath + "config/");
			jsb.fileUtils.removeDirectory(storagePath + "res/");
			jsb.fileUtils.removeDirectory(storagePath + "src/");
			jsb.fileUtils.removeFile(storagePath + "version.manifest");
			jsb.fileUtils.removeFile(storagePath + "project.manifest");
			cc.sys.localStorage.setItem("localVer", packVer);
		}
        */

		jsb.fileUtils.removeFile(storagePath + "project.manifest.temp");


		// cc.log(packManifest.version);
		if(cc.sys.os == cc.sys.OS_IOS && cc.checkNetState() != 0){
			// for appstore review, svr control no update
			var clientVer = jsb.reflection.callStaticMethod("NativeOcSdk", "getBundleVersion");
	        var url = g_strApiDomain + 'check_update.php?clientVer='+clientVer+'&os=' + cc.sys.os;
	        var xhr = cc.loader.getXMLHttpRequest();
	        xhr.open("POST", url);
	        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	        xhr.onreadystatechange = function(){
	            if(xhr.readyState == 4 && xhr.status == 200 && xhr.responseText)
	            {
	            	var response = xhr.responseText;
	            	var ret = JSON.parse(response);
	            	if(ret["hotUp"] == "noHotup"){
		                cc.log("server config no hotup");
		                bSvrUpdate = false;
	            	}

            	    adType = ret["ad"] ? ret["ad"] : "gdt";
	            }
	            NativeStartGame();
	        };

	        xhr.send("");
	    }
	    else{
	    	NativeStartGame();
	    }

	}
	setResPath();
};

function setResPath(){
	if(cc.sys.isNative)return;

	cc.loader.resPath = "";//g_strCdnDomain;
	cc.loader.audioPath = "";//g_strCdnDomain;

	var randSeed = RanDom(1, 1000);

	//cc.loader.load("*.txt") 默认TXT都从 g_strConfDomain 这个路径下的mobile_res目录下拉
	var mwllConfLoader = {
		load: function(realUrl, url, res, cb){
			var v = '';
			var conf_name = cc.path.mainFileName(url);
			if(GameConfig['res_ver'][url] != undefined)
				v = '?v=' + GameConfig['res_ver'][url];
			var config_path = g_strApiDomain + "config/" + url + v;


			cc.loader.loadJson(config_path, function(error, data){
				if(error){
					cb(error)
				}
				else{

					GameConfig[conf_name] = data;
					cb(null, data);
				}


			});
		}
	}
	cc.loader.register(["txt"], mwllConfLoader);
}

cc.game.run();